// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibus.test.messages_lib;

/// Test messages that are used to test the Omnibus library.

/// Message that can hold String key/value pairs
class Data extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Data';

  /// Data map
  final Map<String, String> keyval;

  /// Constructor
  Data(this.keyval) : super(id);

  /// Construct from passive data structure.
  factory Data.fromPds(final Map<String, dynamic> pds) {
    Map<String, String> keyval;

    if (pds.containsKey('keyval') && pds['keyval'] is Map) {
      keyval = new Map<String, String>.from(pds['keyval']);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'keyval'");
    }

    return new Data(keyval);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'keyval': keyval};
  }

  /// Generate funnel.
  Map<String, dynamic> getFunnel() {
    return {};
  }
}

/// Message handler for Data
class DataHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<Data> _callback;

  /// Constructor
  DataHandler(this._callback) : super(Data.id);

  /// Handler entry
  Future<Null> process(OmnibusEvent data) {
    Data message = data is Data ? data : new Data.fromPds(data.toPds());

    return _callback(message);
  }
}

/// Message that has a, b, c values
class Abc extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Abc';

  final String a;

  final String b;

  final String c;

  /// Constructor
  Abc({this.a: '', this.b: '', this.c: ''}) : super(id);

  /// Construct from passive data structure.
  factory Abc.fromPds(final Map<String, dynamic> pds) {
    String a;
    String b;
    String c;

    if (pds.containsKey('a') && pds['a'] is String) {
      a = pds['a'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'a'");
    }

    if (pds.containsKey('b') && pds['b'] is String) {
      b = pds['b'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'b'");
    }

    if (pds.containsKey('c') && pds['c'] is String) {
      c = pds['c'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'c'");
    }

    return new Abc(a: a, b: b, c: c);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'a': a, 'b': b, 'c': c};
  }

  /// Generate funnel.
  Map<String, dynamic> getFunnel() {
    return {'a': a, 'b': b, 'c': c};
  }
}

/// Message handler for Abc
class AbcHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<Abc> _callback;

  /// Constructor
  AbcHandler(this._callback, {String a, String b, String c})
      : super(Abc.id, {'a': a, 'b': b, 'c': c});

  /// Handler entry
  Future<Null> process(OmnibusEvent data) {
    Abc message = data is Abc ? data : new Abc.fromPds(data.toPds());

    return _callback(message);
  }
}

/// Fake request (also used to test for data parsing exceptions)
class FakeRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibus.v0.FakeRequest';

  /// Data map
  final Map<String, List<int>> mapIntList;

  /// Data map
  final Map<String, List<bool>> mapBoolList;

  /// Constructor
  FakeRequest(this.mapIntList, this.mapBoolList) : super(id);

  /// Construct from passive data structure.
  factory FakeRequest.fromPds(final Map<String, dynamic> pds) {
    Map<String, List<int>> mapIntList;
    Map<String, List<bool>> mapBoolList;

    if (pds.containsKey('mapIntList') && pds['mapIntList'] is Map) {
      mapIntList = new Map<String, List<int>>.fromIterable(
          pds['mapIntList'].keys,
          key: (String key1) => key1,
          value: (String key1) => new List<int>.from(pds['mapIntList'][key1]));
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'mapIntList'");
    }

    if (pds.containsKey('mapBoolList') && pds['mapBoolList'] is Map) {
      mapBoolList = new Map<String, List<bool>>.fromIterable(
          pds['mapBoolList'].keys,
          key: (String key1) => key1,
          value: (String key1) =>
              new List<bool>.from(pds['mapBoolList'][key1]));
    } else {
      throw new ArgumentError.value(pds, 'pds',
          "does not contain a valid field for property 'mapBoolList'");
    }

    return new FakeRequest(mapIntList, mapBoolList);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'mapIntList': mapIntList, 'mapBoolList': mapBoolList};
  }

  /// Generate funnel.
  Map<String, dynamic> getFunnel() {
    return {};
  }
}

/// Message handler for FakeRequest
class FakeRequestHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<FakeRequest> _callback;

  /// Constructor
  FakeRequestHandler(this._callback) : super(FakeRequest.id);

  /// Handler entry
  Future<OmnibusResponse> process(OmnibusRequest data) {
    FakeRequest message =
        data is FakeRequest ? data : new FakeRequest.fromPds(data.toPds());

    return _callback(message);
  }
}

/// Fake response (also used to test OmnibusResponse.unchecked)
class FakeResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibus.v0.FakeResponse';

  /// Constructor
  FakeResponse() : super(id);

  /// Construct from passive data structure.
  factory FakeResponse.fromPds(final Map<String, dynamic> pds) {
    return new FakeResponse();
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {};
  }
}

/// Create FakeResponse Stream from the given responses.
Stream<FakeResponse> streamFakeResponse(OmnibusResponses responses) {
  return responses.stream(
      FakeResponse.id,
      (OmnibusResponse data) => data is FakeResponse
          ? data
          : new FakeResponse.fromPds(data.toPds())) as Stream<FakeResponse>;
}

/// Funnel-less event to test funnel indexing
class MessageForAll extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.MessageForAll';

  /// Message text
  final String message;

  /// Constructor
  MessageForAll(this.message) : super(id);

  /// Construct from passive data structure.
  factory MessageForAll.fromPds(final Map<String, dynamic> pds) {
    String message;

    if (pds.containsKey('message') && pds['message'] is String) {
      message = pds['message'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'message'");
    }

    return new MessageForAll(message);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'message': message};
  }

  /// Generate funnel.
  Map<String, dynamic> getFunnel() {
    return {};
  }
}

/// Message handler for MessageForAll
class MessageForAllHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<MessageForAll> _callback;

  /// Constructor
  MessageForAllHandler(this._callback) : super(MessageForAll.id);

  /// Handler entry
  Future<Null> process(OmnibusEvent data) {
    MessageForAll message =
        data is MessageForAll ? data : new MessageForAll.fromPds(data.toPds());

    return _callback(message);
  }
}

/// Email message
class Email extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Email';

  /// Sender
  final String sender;

  /// Receiver
  final String receiver;

  /// Message body
  final String body;

  /// Constructor
  Email(this.body, {this.sender: '', this.receiver: ''}) : super(id);

  /// Construct from passive data structure.
  factory Email.fromPds(final Map<String, dynamic> pds) {
    String sender;
    String receiver;
    String body;

    if (pds.containsKey('sender') && pds['sender'] is String) {
      sender = pds['sender'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'sender'");
    }

    if (pds.containsKey('receiver') && pds['receiver'] is String) {
      receiver = pds['receiver'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'receiver'");
    }

    if (pds.containsKey('body') && pds['body'] is String) {
      body = pds['body'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'body'");
    }

    return new Email(body, sender: sender, receiver: receiver);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'sender': sender, 'receiver': receiver, 'body': body};
  }

  /// Generate funnel.
  Map<String, dynamic> getFunnel() {
    return {'sender': sender, 'receiver': receiver};
  }
}

/// Message handler for Email
class EmailHandler extends OmnibusEventHandler {
  /// Callback
  final OmnibusEventCallback<Email> _callback;

  /// Constructor
  EmailHandler(this._callback, {String sender, String receiver})
      : super(Email.id, {'sender': sender, 'receiver': receiver});

  /// Handler entry
  Future<Null> process(OmnibusEvent data) {
    Email message = data is Email ? data : new Email.fromPds(data.toPds());

    return _callback(message);
  }
}

/// Calculation request message
class CalculationRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibus.v0.CalculationRequest';

  /// First input
  final double a;

  /// Second input
  final double b;

  /// Mathematical operator
  final CalculationOperator op;

  /// Constructor
  CalculationRequest(
      [this.a = 1.0, this.b = 1.0, this.op = CalculationOperator.add])
      : super(id);

  /// Construct from passive data structure.
  factory CalculationRequest.fromPds(final Map<String, dynamic> pds) {
    double a;
    double b;
    CalculationOperator op;

    if (pds.containsKey('a') && pds['a'] is double) {
      a = pds['a'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'a'");
    }

    if (pds.containsKey('b') && pds['b'] is double) {
      b = pds['b'];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'b'");
    }

    if (pds.containsKey('op') && pds['op'] is int) {
      op = CalculationOperator.values[pds['op']];
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'op'");
    }

    return new CalculationRequest(a, b, op);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'a': a, 'b': b, 'op': op.index};
  }

  /// Generate funnel.
  Map<String, dynamic> getFunnel() {
    return {'op': op.index};
  }
}

/// Message handler for CalculationRequest
class CalculationRequestHandler extends OmnibusRequestHandler {
  /// Callback
  final OmnibusRequestCallback<CalculationRequest> _callback;

  /// Constructor
  CalculationRequestHandler(this._callback, {int op})
      : super(CalculationRequest.id, {'op': op});

  /// Handler entry
  Future<OmnibusResponse> process(OmnibusRequest data) {
    CalculationRequest message = data is CalculationRequest
        ? data
        : new CalculationRequest.fromPds(data.toPds());

    return _callback(message);
  }
}

/// Calculation request response
class CalculationResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibus.v0.CalculationResponse';

  /// Calculation result
  final CalculationResult result;

  /// Constructor
  CalculationResponse(this.result) : super(id);

  /// Construct from passive data structure.
  factory CalculationResponse.fromPds(final Map<String, dynamic> pds) {
    CalculationResult result;

    if (pds.containsKey('result') && pds['result'] is double) {
      result = new CalculationResult.fromPds(pds['result'] as double);
    } else {
      throw new ArgumentError.value(
          pds, 'pds', "does not contain a valid field for property 'result'");
    }

    return new CalculationResponse(result);
  }

  /// Generate passive data structure from message properties.
  Map<String, dynamic> toPds() {
    return {'result': result.toPds()};
  }
}

/// Create CalculationResponse Stream from the given responses.
Stream<CalculationResponse> streamCalculationResponse(
    OmnibusResponses responses) {
  return responses.stream(
          CalculationResponse.id,
          (OmnibusResponse data) => data is CalculationResponse
              ? data
              : new CalculationResponse.fromPds(data.toPds()))
      as Stream<CalculationResponse>;
}
